% CoMa2 - SS11
% Aufg.5.2

% Test der summ. Trapezregel, summ. Simpsonregel und summ. 3/8-Regel

clear all

%% Integrand: f(x) = sin(x), Intervall: [0,pi]

n = 6:6:300;

f = @(x) sin(x);
exakt = 2;
diskrfehler1 = zeros(1,length(n));  aufwand1 = zeros(1,length(n));
diskrfehler2 = zeros(1,length(n));  aufwand2 = zeros(1,length(n));
diskrfehler3 = zeros(1,length(n));  aufwand3 = zeros(1,length(n));

for j=1:length(n)
    [S,aufwand1(j)] = sumnc([0,pi],f,n(j),1);
    diskrfehler1(j) = abs(exakt-S);
    [S,aufwand2(j)] = sumnc([0,pi],f,n(j),2);
    diskrfehler2(j) = abs(exakt-S);
    [S,aufwand3(j)] = sumnc([0,pi],f,n(j),3);
    diskrfehler3(j) = abs(exakt-S);
end

figure(1);
loglog(n,diskrfehler1,'c');
hold on
loglog(n,diskrfehler2,'r');
loglog(n,diskrfehler3,'b');
hold off
title('Diskretisierungsfehler ber n; f(x) = sin(x); I=[0,\pi]');
legend('Trapezregel','Simpsonregel','3/8-Regel');
xlabel('n');
ylabel('Fehler');

figure(2);
loglog(aufwand1,diskrfehler1,'c');
hold on
loglog(aufwand2,diskrfehler2,'r');
loglog(aufwand3,diskrfehler3,'b');
hold off
title('Fehler ber Aufwand; f(x) = sin(x); I=[0,\pi]');
legend('Trapezregel','Simpsonregel','3/8-Regel');
xlabel('Aufwand');
ylabel('Fehler');

%% Integrand: f(x) = \sqrt(x)+sin(21\pi x), Intervall: [0,1]

n = 6:6:12000;

f = @(x) sqrt(x) + sin(21*pi*x);
% schauen wir uns doch erst den Integranden an
figure(3);
plot(0:0.001:1,f(0:0.001:1));
title('f(x) = sqrt(x) + sin(21\pi x) auf [0,1]');

exakt = (2/3) + 2/(21*pi);
diskrfehler1 = zeros(1,length(n));  aufwand1 = zeros(1,length(n));
diskrfehler2 = zeros(1,length(n));  aufwand2 = zeros(1,length(n));
diskrfehler3 = zeros(1,length(n));  aufwand3 = zeros(1,length(n));

for j=1:length(n)
    [S,aufwand1(j)] = sumnc([0,1],f,n(j),1);
    diskrfehler1(j) = abs(exakt-S);
    [S,aufwand2(j)] = sumnc([0,1],f,n(j),2);
    diskrfehler2(j) = abs(exakt-S);
    [S,aufwand3(j)] = sumnc([0,1],f,n(j),3);
    diskrfehler3(j) = abs(exakt-S);
end

figure(4);
loglog(n,diskrfehler1,'c');
hold on
loglog(n,diskrfehler2,'r');
loglog(n,diskrfehler3,'b');
hold off
title('Diskretisierungsfehler ber n; f(x) = sqrt(x) + sin(21\pi x); I=[0,1]');
legend('Trapezregel','Simpsonregel','3/8-Regel');
xlabel('n');
ylabel('Fehler');

figure(5);
loglog(aufwand1,diskrfehler1,'c');
hold on
loglog(aufwand2,diskrfehler2,'r');
loglog(aufwand3,diskrfehler3,'b');
hold off
title('Fehler ber Aufwand; f(x) = sqrt(x) + sin(21\pi x); I=[0,1]');
legend('Trapezregel','Simpsonregel','3/8-Regel');
xlabel('Aufwand');
ylabel('Fehler');